/**
 * Jose Luis Alonzo Velazquez
 * Ejemplo de poligono girando
 * Aqui utilizamos traslaciones y rotaciones
 * Uso de la funcion idle, ademas de keyboard special
 * crecion de algunas figuras geometricas y cambio de color
 */
#include <windows.h>
#include <GL/glut.h>
#include <stdlib.h>
#include <iostream>
#include <math.h>

using namespace std;
//Variables globales
const int W_WIDTH = 500; // Tamao incial de la ventana
const int W_HEIGHT = 500;
const int limite_x = 10;//indico los limites en coordenadas
const int limite_y = 10;
static bool bandera_cuadros=false;//indico si  pinto cuadros
static bool bandera_circulos=false;//indico si  pinto circulos
GLfloat fAngulo; // Variable que indica el ngulo de rotacin de los ejes.
static GLfloat angle_aux=.1;//Angulo auxiliar
GLfloat fScale; // Variable que indica el escalamiento.
//static GLfloat scale_aux=.1;//auxiliar de escalamiento.
GLfloat move_x;
GLfloat move_y;
const GLfloat aux_move=.5;
GLfloat lightPos[4] = {1.0, 4.0, 7.5, 1.0}; // Luz direccional
GLdouble eyex=0.0,eyey=0.0,eyez=1.0,posx=0.0,posy=0.0,posz=0.0,upx=0.0, upy=0.0, upz=-1.0;

/**Circulo 2D*/
void circulo(int xc, int yc, int rad){
    float x,y,angle_radians;
    glBegin(GL_LINE_LOOP);
    glColor3f(0,0,0);
    for (int angle=0; angle<365; angle=angle+5){
        angle_radians = angle * (float)3.14159 / (float)180;
        x = xc + rad * (float)cos(angle_radians);
        y = yc + rad * (float)sin(angle_radians);
        glVertex3f(x,y,0);
    }
    glEnd();
}

/**Circulo 2D*/
void circulo7f(float xc, float yc,float zc, float rad,float R,float G,float B){
    float x,y,z,angle_radians;
    glBegin(GL_POLYGON);
    glColor3f(R,G,B);
    z=zc;
    for (int angle=0; angle<365; angle=angle+5){
        angle_radians = angle * (float)3.14159 / (float)180;
        x = xc + rad * (float)cos(angle_radians);
        y = yc + rad * (float)sin(angle_radians);
        glVertex3f(x,y,z);
    }
    glEnd();
}

void cuadro7f(float x,float y,float z,float lado,float R,float G,float B){
    glColor3f(R,G,B);
    glBegin(GL_POLYGON);
        glVertex3f(x,y,z);
        glVertex3f(x+lado,y,z);
        glVertex3f(x+lado,y-lado,z);
        glVertex3f(x,y-lado,z);
    glEnd();
}


void estrella(){
    glBegin (GL_POLYGON);
    glColor3f (1.0f, 1.0f, 1.0f);
    glVertex3f(0.0f, 0.0f, 0.0f);
    glColor3f (0.0f, 1.0f, 0.0f);
    glVertex3f(1.0f, 0.0f, 0.0f);
    glColor3f (0.0f, 1.0f, 0.0f);
    glVertex3f(-0.5f, 0.866f, 0.0f);
    glEnd();

    glBegin (GL_POLYGON);
    glColor3f (1.0f, 1.0f, 1.0f);
    glVertex3f(0.0f, 0.0f, 0.0f);
    glColor3f (1.0f, 0.0f, 0.0f);
    glVertex3f(1.0f, 0.0f, 0.0f);
    glColor3f (0.0f, 0.0f, 1.0f);
    glVertex3f(-0.5f, -0.866f, 0.0f);
    glEnd();

    glBegin (GL_POLYGON);
    glColor3f (1.0f, 1.0f, 1.0f);
    glVertex3f(0.0f, 0.0f, 0.0f);
    glColor3f (0.0f, 1.0f, 1.0f);
    glVertex3f(-0.5f, 0.866f, 0.0f);
    glColor3f (0.0f, 0.0f, 1.0f);
    glVertex3f(-0.5f, -0.866f, 0.0f);
    glEnd();
}
void boca(int xc, int yc, int rad){
    float x,y,angle_radians;
    glBegin(GL_POLYGON);
    glColor3f(1,0,0);
    for (int angle=210; angle<335; angle=angle+5){
        angle_radians = angle * (float)3.14159 / (float)180;
        x = xc + rad * (float)cos(angle_radians);
        y = yc + rad * (float)sin(angle_radians);
        glVertex3f(x,y,0);

    }
    glEnd();
}
// Funcin que visualiza la escena OpenGL
void Display (void) {
    // Borramos la escena
    glClear (GL_COLOR_BUFFER_BIT);//que pasa si quitamos esta instruccion
    if(bandera_cuadros==true){
        cuadro7f(-10,10,0,10,1.0,0.0,0.0);
        cuadro7f(0,10,0,10,0.0,1.0,0.0);
        cuadro7f(0,0,0,10,1.0,0.0,1.0);
        cuadro7f(-10,0,0,10,1.0,1.0,0.0);
    }
    if(bandera_circulos==true){
        circulo7f(-5,5,0,2,0.0,0.0,0.0);
        circulo7f(5,5,0,2,0.0,0.0,0.0);
        circulo7f(5,-5,0,2,0.0,0.0,0.0);
        circulo7f(-5,-5,0,2,0.0,0.0,0.0);
    }
    glPushMatrix();
    glScalef(.5,.5,.5);
    glPushMatrix();
    //gluLookAt(2, 2, 6, 0, 0, 0, 0, 1, 0);

    glTranslatef(0,0,5);
    circulo(0,0,10);
    circulo(4,4,1);
    circulo(-4,4,1);
    glTranslatef(move_x,move_y,0);
// Rotamos las proximas primitivas
    glRotatef (fAngulo, 0.0f, 0.0f, 1.0f);
    //glScalef(.5,.5,.5);
// Creamos a continuacin dibujamos los tres poligonos
    estrella();
    glPopMatrix();

    glPushMatrix();
    glTranslatef(4,4,0);
    estrella();
    glPopMatrix();

    glPushMatrix();
    glTranslatef(-4,4,0);
    estrella();
    glPopMatrix();

    glPushMatrix();
    boca(0,0,5);
    glPopMatrix();
    glPopMatrix();
    glFlush();//para cuando utilizamos un unico buffer
    //glutSwapBuffers();//para cuando utilizamos doble buffer
}

// Funcin que se ejecuta cuando el sistema no esta ocupado
void Idle (void) {
// Incrementamos el ngulo
    fAngulo += angle_aux;
// Si es mayor que dos pi la decrementamos
    if (fAngulo > 360)
        fAngulo -= 360;
    if (fAngulo < 0.0)
        fAngulo = 360;
// Indicamos que es necesario repintar la pantalla
    glutPostRedisplay();
//Aqui imprimo el valor del angulo en cada momento
    //cout << fAngulo << endl;
}
//Esta funcion se encarga de Manejar el teclado
static void key(unsigned char key, int x, int y){
    switch (key){
        case 27 :
        case 'q':
            exit(0);
            break;
        case '+':
            if(fAngulo < 360)
                angle_aux+=aux_move;
            break;
        case '-':
            if(fAngulo > 0)
                angle_aux-=aux_move;
            break;
        case 'd':
            move_x+=aux_move;
            if(move_x>limite_x)
                move_x=-limite_x;
            break;
        case 'a':
            move_x-=aux_move;
            if(move_x<-limite_x)
                move_x=limite_x;
            break;
        case 'w':
                move_y+=aux_move;
            break;
        case 's':
                move_y-=aux_move;
            break;
    }
    glutPostRedisplay();
}
//Esta funcion se encarga de Manejar teclas especiales en el teclado
void SpecialKeys(int key, int x, int y){
    switch (key){
        case GLUT_KEY_RIGHT:
            move_x+=aux_move;
            if(move_x>limite_x)
                move_x=-limite_x;
            break;
        case GLUT_KEY_LEFT:
            move_x-=aux_move;
            if(move_x<-limite_x)
                move_x=limite_x;
            break;
        case GLUT_KEY_UP:
                move_y+=aux_move;
                if(move_y>limite_y)
                    move_y=-limite_y;
            break;
        case GLUT_KEY_DOWN:
                move_y-=aux_move;
                if(move_y<-limite_y)
                    move_y=limite_y;
            break;
        case GLUT_KEY_F1:
            glClearColor (1.0f, 1.0f, 1.0f, 1.0f);
            break;
        case GLUT_KEY_F2:
            glClearColor (1.0f, 0.0f, 0.0f, 1.0f);
            break;
        case GLUT_KEY_F3:
            glClearColor (0.0f, 1.0f, 0.0f, 1.0f);
            break;
        case GLUT_KEY_F4:
            glClearColor (0.0f, 0.0f, 0.0f, 1.0f);
            break;
        case GLUT_KEY_PAGE_UP:
            bandera_cuadros=true;
            break;
        case GLUT_KEY_PAGE_DOWN:
            bandera_cuadros=false;
            break;
        case GLUT_KEY_HOME:
            bandera_circulos=true;
            break;
        case GLUT_KEY_END:
            bandera_circulos=false;
            break;
    }
    glutPostRedisplay();
}

// Funcin principal
int main(int argc, char **argv) {
// Inicializamos la librera GLUT
    glutInit (&argc, argv);
// Indicamos como ha de ser la nueva ventana
    glutInitWindowPosition (100,100);
    glutInitWindowSize (W_WIDTH, W_HEIGHT);
//Aqui solo utilizamos un solo buffer por eso se ve parpadear
    glutInitDisplayMode (GLUT_RGBA | GLUT_SINGLE);
//Aqui utilizamos un doble buffer por eso no se ve parpadear
    //glutInitDisplayMode (GLUT_RGBA | GLUT_DOUBLE);
// Creamos la nueva ventana
    glutCreateWindow ("Mi primer Juego en OpenGL");
// Indicamos cuales son las funciones de redibujado e idle
    glutDisplayFunc(Display);
    glutIdleFunc(Idle);
    glutKeyboardFunc(key);
    glutSpecialFunc(SpecialKeys);
// El color de fondo ser el negro (RGBA, RGB + Alpha channel)
    glClearColor (1.0f, 1.0f, 1.0f, 1.0f);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    //aqui indico que es lpo que sera visible
    glOrtho (-10.0, 10.0f, -10.0, 10.0f, -10.0, 10.0f);
    glMatrixMode(GL_MODELVIEW);
// Comienza la ejecucin del core de GLUT
    glutMainLoop();
    return 0;
}
